c     Copyright (C)
c     2008-2013 Universit Paul Sabatier
c     2008-2013 Centre National de la Recherche Scientifique
c     2008-2013 Ecole des Mines d'Albi
c     2008-2013 Universit de Bordeaux 1
c     2008-2013 Fondation STAE
c     2014-2018 Meso-Star
c     
c     This file must be used under the terms of the CeCILL license.
c     This source file is licensed as described in the file COPYING, which
c     you should have received as part of this distribution.  The terms
c     are also available at
c     http://www.cecill.info/licences/Licence_CeCILL_V2.1-en.txt
c     
      subroutine read_special_molecules(nsmol,smol_name,smol_mass)
      implicit none
      include 'max.inc'
      include 'formats.inc'
      integer i,strlen,ios,nsmol,mol,nl
      double precision smol_mass(1:Nmol_max)
      character*(Nchar_mx) file_specmol,nlines_file
      character*10 smol_name(1:Nmol_max,1:2)


      file_specmol='./data/special_molecules.in'
      open(11,file=file_specmol(1:strlen(file_specmol)),
     &        status='old',iostat=ios)
      if (ios.ne.0) then        ! file not found
         write(*,*) 'Error from routine read_composition:'
         write(*,*) 'Data file could not be found:'
         write(*,*) file_specmol(1:strlen(file_specmol))
         stop
      else
         write(*,*) 'Reading special molecules list in file:'
         write(*,*) file_specmol(1:strlen(file_specmol))
      endif
      nlines_file='./nlines'
      call get_nlines(file_specmol,nlines_file,nl)
      nsmol=nl-3
      do i=1,3
         read(11,*)
      enddo
      do mol=1,nsmol
         read(11,*) smol_name(mol,1),smol_name(mol,2),smol_mass(mol)
      enddo
      close(11)

      return
      end
